#include "csapp.h"

int main(int argc, char **argv, char **envp) {
  char *hostname, *portno;
  struct addrinfo hints, *addrs;
  char host[256], serv[32];
  int s;
  size_t amt;

  if (argc != 3)
    app_error("need <hostname> <port>");

  hostname = argv[1];
  portno = argv[2];

  memset(&hints, 0, sizeof(struct addrinfo));
  hints.ai_family = AF_INET;      /* Request IPv4 */
  hints.ai_socktype = SOCK_DGRAM; /* UDP connection */
  Getaddrinfo(hostname, portno, &hints, &addrs);

  Getnameinfo(addrs->ai_addr, addrs->ai_addrlen,
              host, sizeof(host),
              serv, sizeof(serv),
              NI_NUMERICHOST | NI_NUMERICSERV);
  printf("sending to %s:%s\n", host, serv);

  while (1) {
    long now_s;

    s = Socket(addrs->ai_family, addrs->ai_socktype, addrs->ai_protocol);
    amt = Sendto(s, "hi", 2, 0,
		 addrs->ai_addr, addrs->ai_addrlen);
    
    Recv(s, &now_s, sizeof(long), 0);
    printf("%ld\n", now_s);
  }

  Freeaddrinfo(addrs);
  
  return (amt != strlen(argv[3]));
}
